ICETEXIT TITLE 'SAMPLE ICETEXIT ROUTINE'
*---------------------------------------------------------------------*
*       SAMPLE ICETEXIT ROUTINE.                                      *
*       PURPOSE:                                                      *
*           THIS ROUTINE WILL COMBINE ALL OF THE DATA AREAS PASSED    *
*           TO ICETEXIT IN ONE USER SMF RECORD ID 129. THESE          *
*           RECORDS CAN THEN BE ANALIZED AS A GROUP.                  *
*                                                                     *
* NOTES:                                                              *
*   1) SEE "DFSORT INSTALLATION AND CUSTOMIZATION" FOR FULL DETAILS   *
*      ON ICETEXIT                                                    *
*   2) THIS EXAMPLE ASSUMES THE USE OF SVC 249 - CHANGE IT AS         *
*      APPROPRIATE IF YOU USE A DIFFERENT SVC                         *
*                                                                     *
* REQUIRED DFSORT MACROS: ICESMF, ICEDTEX                             *
* REQUIRED SYSTEM MACROS: SAVE, GETMAIN, TIME, FREEMAIN, RETURN,      *
*                         CVT, IEESMCA, YREGS                         *
*---------------------------------------------------------------------*
         SPACE 1
ICETEXIT CSECT
ICETEXIT AMODE 24
ICETEXIT RMODE 24
         SPACE 1
*---------------------------------------------------------------------*
*        INITIALIZATION.                                              *
*---------------------------------------------------------------------*
         SPACE 1
         SAVE  (14,12),,ICETEXIT-&SYSDATE-&SYSTIME
         LR    R12,R15             EPA FOR BASE
         USING ICETEXIT,R12
         LR    R11,R1              SAVE ICETPAR ADDR
         USING ICETPAR,R11
         LA    R0,DSALTH           LENGTH OF DSA TO GETMAIN
       GETMAIN RC,LV=(0)
         LTR   R15,R15             DID WE GET STORAGE?
         BNZ   S01L990                NO..THEN GET OUT
         ST    R1,8(,R13)          FORWARD CHAIN
         ST    R13,4(,R1)          BACKWARD CHAIN
         LR    R13,R1              ->NEW SAVE AREA
         USING DSA,R13
         SPACE 1
*---------------------------------------------------------------------*
*        COMPUTE SIZE OF USER SMF RECORD TO BE BUILT.                 *
*---------------------------------------------------------------------*
         SPACE 1
         L     R0,SDASMFL          LENGTH OF CONSTANT PORTIONS
         ICM   R1,B'1111',ICETSMFA  ->SORT SMF RECORD
         BZ    S01L100                 BRANCH IF NOT ONE..
         USING ICESMFH,R1
         AH    R0,ICERDW           + LENGTH
         DROP  R1
         SPACE 1
S01L100  DS    0H
         ST    R0,DSASMFL          SAVE FOR LATER FREEMAIN
       GETMAIN RC,LV=(0)
         LTR   R15,R15             DID WE GET THE STORAGE?
         BNZ   S01L950               NO..THEN EXIT
         LR    R8,R1               LOAD FOR BASE
         USING ICE81RCD,R8
         SPACE 1
         LR    R0,R1               TO ADDR
         L     R1,DSASMFL          TO LENGTH
         SR    R14,R14             NO FROM ADDR
         LR    R15,R14             NO FROM LENGTH
         MVCL  R0,R14              ZERO THE AREA
         SPACE 1
*---------------------------------------------------------------------*
*        NOW BUILD THE SMF HEADER.                                    *
*---------------------------------------------------------------------*
         SPACE 1
         MVI   ICE81RTY,129        SET RECORD TYPE
         TIME  BIN
         STCM  R0,15,ICE81TME      SAVE TIME
         STCM  R1,15,ICE81DTE      SAVE DATE
         L     R1,16               ->CVT
         USING CVT,R1
         L     R1,CVTSMCA          ->SMCA
         USING SMCABASE,R1
         MVC   ICE81SID,SMCASID    GET SYSID
         DROP  R1
         LA    R9,ICE81LTH         LENGTH OF HEADER
         LA    R10,0(R9,R8)        ->FIRST AVAILABLE POSITION
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE DFSORT SMF RECORD.                                *
*---------------------------------------------------------------------*
         SPACE 1
         ICM   R2,B'1111',ICETSMFA    -> DFSORT SMF RECORD
         BZ    S01L110                BRANCH IF NONE
         SPACE 1
         STH   R9,ICE81ROF         SAVE OFFSET
         USING ICESMFH,R2
         LH    R1,ICERDW           LENGTH OF SMF RECORD
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE SMF STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L110  DS    0H
         ICM   R2,B'1111',ICETSST    -> SMF STATISTICS
         BZ    S01L120               BRANCH IF NONE
         STH   R9,ICE81SOF         SAVE OFFSET
         USING ICESST,R2
         L     R1,ICESMFST         LENGTH OF SMF STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE GENERAL STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L120  DS    0H
         ICM   R2,B'1111',ICETGEN    -> GEN STATISTICS
         BZ    S01L130               BRANCH IF NONE
         STH   R9,ICE81GOF         SAVE OFFSET
         USING ICEGEN,R2
         L     R1,ICEGSTAT         LENGTH OF GEN STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE OPTIONS STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L130  DS    0H
         ICM   R2,B'1111',ICETOPTS   -> OPTIONS STATISTICS
         BZ    S01L140               BRANCH IF NONE
         STH   R9,ICE81OOF         SAVE OFFSET
         USING ICEOPTS,R2
         L     R1,ICEOSTAT         LENGTH OF OPTIONS STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE SORT/MERGE STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L140  DS    0H
         ICM   R2,B'1111',ICETSMS    -> SORT/MERGE STATISTICS
         BZ    S01L150               BRANCH IF NONE
         STH   R9,ICE81MOF         SAVE OFFSET
         USING ICESMS,R2
         L     R1,ICEFSTAT         LENGTH OF SORT/MERGE STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE VIRTUAL STORAGE STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L150  DS    0H
         ICM   R2,B'1111',ICETVIRT   -> VIRTUAL STORAGE STATISTICS
         BZ    S01L160               BRANCH IF NONE
         STH   R9,ICE81VOF         SAVE OFFSET
         USING ICEVSTOR,R2
         L     R1,ICEVSTAT         LENGTH OF VIRTUAL STORAGE STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE PHASE TIMING STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L160  DS    0H
         ICM   R2,B'1111',ICETPTIM   -> PHASE TIMING STATISTICS
         BZ    S01L170               BRANCH IF NONE
         STH   R9,ICE81TOF         SAVE OFFSET
         USING ICEPHAST,R2
         L     R1,ICEPTIME         LENGTH OF PHASE TIMING STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE SORTIN STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L170  DS    0H
         ICM   R2,B'1111',ICETSIN    -> SORTIN STATISTICS
         BZ    S01L180               BRANCH IF NONE
         STH   R9,ICE81XOF         SAVE OFFSET
         USING ICESRTIN,R2
         L     R1,ICESORTI         LENGTH OF SORTIN STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE SORTOUT STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L180  DS    0H
         ICM   R2,B'1111',ICETSOUT   -> SORTOUT STATISTICS
         BZ    S01L190               BRANCH IF NONE
         STH   R9,ICE81ZOF         SAVE OFFSET
         USING ICESRTOT,R2
         L     R1,ICESORTO         LENGTH OF SORTOUT STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE SORTWK STATISTICS.                                *
*---------------------------------------------------------------------*
         SPACE 1
S01L190  DS    0H
         ICM   R15,B'1111',ICETSWK    -> SORTWK STATISTICS
         BZ    S01L200               BRANCH IF NONE
         STH   R9,ICE81WOF         SAVE OFFSET
         USING ICEWRKDS,R15
         L     R1,ICESORTW         LENGTH OF SORTWK STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R2,R15              FROM ADDRESS
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE SORTWK DATA SET ENTRIES.                          *
*---------------------------------------------------------------------*
         SPACE 1
         LH    R7,ICESWKEN         # SORTWK DATA SET ENTRIES
         STH   R7,ICE81EEN         SAVE IN SMF RECORD
         STH   R9,ICE81EOF         SAVE OFFSET
         LA    R15,ICESWK01        ->FIRST IN LIST
         DROP  R15
S01L195  DS    0H
         L     R2,0(,R15)          ->ICEWORK
         USING ICEWORK,R2
         L     R1,ICESWORK         LENGTH OF SORTWK DATA SET ENTRY
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         SPACE 1
         LA    R15,4(,R15)         ->NEXT IN LIST
         BCT   R7,S01L195          DO ALL IN LIST
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE HIPERSORTING STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L200  DS    0H
         ICM   R2,B'1111',ICETHIPR   -> HIPERSORTING STATISTICS
         BZ    S01L205               BRANCH IF NONE
         STH   R9,ICE81HOF         SAVE OFFSET
         USING ICEHIPER,R2
         L     R1,ICEHSORT         LENGTH OF HIPERSORTING STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        APPEND THE DATASPACE SORTING STATISTICS.
*---------------------------------------------------------------------*
         SPACE 1
S01L205  DS    0H
         ICM   R2,B'1111',ICETDATA   -> DATASPACE SORTING STATISTICS
         BZ    S01L220               BRANCH IF NONE
         STH   R9,ICE81DOF         SAVE OFFSET
         USING ICEDATAS,R2
         L     R1,ICEDSORT         LENGTH OF DATASPACE SORTING STATS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              ->AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT SMF RECORD
         DROP  R2
         SPACE 1
**********************************************************************
* APPEND THE DFSORT MEMORY OBJECT STATISTICS. *
**********************************************************************
         SPACE 1
S01L215  ICM   R2,B1111,ICETMO     -> MEMORY OBJECT STATISTICS
         BZ    S01L220               BRANCH IF NONE
         STH   R9,ICE81NOF         SAVE OFFSET
         USING ICEMOSEC,R2
         L     R1,ICEMOLNG         LENGTH OF MEMORY OBJECT STATISTICS
         LR    R0,R10              TO ADDRESS
         AR    R9,R1               INCREMENT LENGTH/OFFSET
         AR    R10,R1              -> AFTER SMF RECORD
         LR    R3,R1               FROM LENGTH
         MVCL  R0,R2               APPEND DFSORT MEMORY OBJECT STATS
         DROP  R2
         SPACE 1
*---------------------------------------------------------------------*
*        SMF RECORD IS BUILT. SEND IT OFF TO SMF.                     *
*---------------------------------------------------------------------*
         SPACE 1
S01L220  DS    0H
         STH   R9,ICE81LEN         SAVE IN RDW
         BAL   R15,S01L210         BRANCH AROUND LABEL
         DC    C'USMF'             SVC PASSWORD
S01L210  DS    0H
         L     R0,0(,R15)          LOAD INTO PARM REGISTER
         LR    R1,R8               -> USER SMF RECORD
*******************************************************************
* SVC 249 IS USED IN THIS EXAMPLE - CHANGE THIS CALL AS APPROPRIATE
*******************************************************************
         SVC   249                 CALL SVC TO WRITE RECORD
         SPACE 1
*---------------------------------------------------------------------*
*        ALL DONE. FREE STORAGE AND RETURN.                           *
*---------------------------------------------------------------------*
         SPACE 1
         LR    R1,R8               -> SMF RECORD
         L     R0,DSASMFL          LENGTH OF AREA
      FREEMAIN R,LV=(0),A=(1)
         SPACE 1
S01L950  DS    0H
         LA    R0,DSALTH           LENGTH OF AREA
         LR    R1,R13              ->AREA
         L     R13,4(,R1)          ->CALLER'S SAVEAREA
      FREEMAIN R,LV=(0),A=(1)
         SPACE 1
S01L990  DS    0H
        RETURN (14,12),,RC=0
         TITLE 'S D A - STATIC STORAGE AREA (CONSTANTS)'
         SPACE 1
*        CONSTANT DEFINING THE COMBINED LENGTHS OF ALL DATA AREAS
*        EXCEPT FOR THE DFSORT SMF RECORD (ICESMF)
         SPACE 1
SDASMFL  DC    A(ICE81LTH+L'ICESMEND+L'ICEGNEND+L'ICEOEND+L'ICESSEND+L'X
               ICEVEND+L'ICETMEND+L'ICESNEND+L'ICESOEND+L'ICESWEND+(32*X
               L'ICESEEND)+L'ICEHREND+L'ICEDSEND+L'ICEMOEND)
         TITLE 'D S A - DYNAMIC STORAGE AREA'
DSA      DSECT
DSASAVE  DS    18A                 SAVE AREA
DSASMFL  DS    F                   LENGTH OF USER SMF RECORD AREA
DSALTH   EQU   (*-DSA)             LENGTH OF DSA
         TITLE 'DFSORT USER SMF RECORD GENERATED FROM ICETEXIT ROUTINE'
         SPACE 1
ICE81RCD DSECT
ICE81LEN DS    H                   RECORD LENGTH
ICE81SEG DS    H                   SEGMENT DESCRIPTOR
ICE81FLG DS    XL1                 SYSTEM INDICATOR
ICE81RTY DS    AL1                 RECORD TYPE = AL1(129)
ICE81TME DS    XL4                 TIME, IN HUNDREDTHS OF A SECOND
ICE81DTE DS    PL4                 DATE, IN FORM 00YYDDDF
ICE81SID DS    CL4                 SYSTEM IDENTIFICATION
         SPACE 1
ICE81ROF DS    H                   OFFSET TO SORT SMF RECORD (ICESMF  )
ICE81SOF DS    H                   OFFSET TO SMF STATS       (ICESST  )
ICE81GOF DS    H                   OFFSET TO GENERAL STATS   (ICEGEN  )
ICE81OOF DS    H                   OFFSET TO OPTION STATS    (ICEOPTS )
ICE81MOF DS    H                   OFFSET TO SORT/MERGE STAT (ICESMS  )
ICE81VOF DS    H                   OFFSET TO VIRT STOR. STAT (ICEVSTOR)
ICE81TOF DS    H                   OFFSET TO TIMING STATS    (ICEPHAST)
ICE81XOF DS    H                   OFFSET TO SORTIN STATS    (ICESRTIN)
ICE81ZOF DS    H                   OFFSET TO SORTOUT STATS   (ICESRTOT)
ICE81WOF DS    H                   OFFSET TO SORTWK STATS    (ICEWRKDS)
ICE81EOF DS    H                   OFFSET TO SORTWK ENTRY    (ICEWORK )
ICE81EEN DS    H                   # OF ICEWORK ENTRIES
ICE81HOF DS    H                   OFFSET TO HIPER STATS     (ICEHIPER)
ICE81DOF DS    H                   OFFSET TO DATASPACE STATS (ICEDATAS)
ICE81NOF DS    H                   OFFSET TO MEM. OBJ. STATS (ICEMOSEC)
ICE81LTH EQU   *-ICE81RCD          LENGTH OF COMMON PORTION
        ICESMF
        ICEDTEX
         PRINT NOGEN
         CVT   LIST=NO,DSECT=YES
       IEESMCA
         YREGS
         END
